// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use glib::object::Cast;
use glib::object::IsA;
use glib::signal::connect_raw;
use glib::signal::SignalHandlerId;
use glib::translate::*;
use glib::StaticType;
use glib::ToValue;
use glib_sys;
use gspell_sys;
use gtk;
use std::boxed::Box as Box_;
use std::fmt;
use std::mem::transmute;

glib_wrapper! {
    pub struct TextView(Object<gspell_sys::GspellTextView, gspell_sys::GspellTextViewClass, TextViewClass>);

    match fn {
        get_type => || gspell_sys::gspell_text_view_get_type(),
    }
}

impl TextView {
    pub fn get_from_gtk_text_view<P: IsA<gtk::TextView>>(gtk_view: &P) -> Option<TextView> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_none(gspell_sys::gspell_text_view_get_from_gtk_text_view(
                gtk_view.as_ref().to_glib_none().0,
            ))
        }
    }
}

#[derive(Clone, Default)]
pub struct TextViewBuilder {
    enable_language_menu: Option<bool>,
    inline_spell_checking: Option<bool>,
    view: Option<gtk::TextView>,
}

impl TextViewBuilder {
    pub fn new() -> Self {
        Self::default()
    }

    pub fn build(self) -> TextView {
        let mut properties: Vec<(&str, &dyn ToValue)> = vec![];
        if let Some(ref enable_language_menu) = self.enable_language_menu {
            properties.push(("enable-language-menu", enable_language_menu));
        }
        if let Some(ref inline_spell_checking) = self.inline_spell_checking {
            properties.push(("inline-spell-checking", inline_spell_checking));
        }
        if let Some(ref view) = self.view {
            properties.push(("view", view));
        }
        let ret = glib::Object::new(TextView::static_type(), &properties)
            .expect("object new")
            .downcast::<TextView>()
            .expect("downcast");
        ret
    }

    pub fn enable_language_menu(mut self, enable_language_menu: bool) -> Self {
        self.enable_language_menu = Some(enable_language_menu);
        self
    }

    pub fn inline_spell_checking(mut self, inline_spell_checking: bool) -> Self {
        self.inline_spell_checking = Some(inline_spell_checking);
        self
    }

    pub fn view<P: IsA<gtk::TextView>>(mut self, view: &P) -> Self {
        self.view = Some(view.clone().upcast());
        self
    }
}

pub const NONE_TEXT_VIEW: Option<&TextView> = None;

pub trait TextViewExt: 'static {
    fn basic_setup(&self);

    fn get_enable_language_menu(&self) -> bool;

    fn get_inline_spell_checking(&self) -> bool;

    fn get_view(&self) -> Option<gtk::TextView>;

    fn set_enable_language_menu(&self, enable_language_menu: bool);

    fn set_inline_spell_checking(&self, enable: bool);

    fn connect_property_enable_language_menu_notify<F: Fn(&Self) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId;

    fn connect_property_inline_spell_checking_notify<F: Fn(&Self) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId;
}

impl<O: IsA<TextView>> TextViewExt for O {
    fn basic_setup(&self) {
        unsafe {
            gspell_sys::gspell_text_view_basic_setup(self.as_ref().to_glib_none().0);
        }
    }

    fn get_enable_language_menu(&self) -> bool {
        unsafe {
            from_glib(gspell_sys::gspell_text_view_get_enable_language_menu(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn get_inline_spell_checking(&self) -> bool {
        unsafe {
            from_glib(gspell_sys::gspell_text_view_get_inline_spell_checking(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn get_view(&self) -> Option<gtk::TextView> {
        unsafe {
            from_glib_none(gspell_sys::gspell_text_view_get_view(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    fn set_enable_language_menu(&self, enable_language_menu: bool) {
        unsafe {
            gspell_sys::gspell_text_view_set_enable_language_menu(
                self.as_ref().to_glib_none().0,
                enable_language_menu.to_glib(),
            );
        }
    }

    fn set_inline_spell_checking(&self, enable: bool) {
        unsafe {
            gspell_sys::gspell_text_view_set_inline_spell_checking(
                self.as_ref().to_glib_none().0,
                enable.to_glib(),
            );
        }
    }

    fn connect_property_enable_language_menu_notify<F: Fn(&Self) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn notify_enable_language_menu_trampoline<P, F: Fn(&P) + 'static>(
            this: *mut gspell_sys::GspellTextView,
            _param_spec: glib_sys::gpointer,
            f: glib_sys::gpointer,
        ) where
            P: IsA<TextView>,
        {
            let f: &F = &*(f as *const F);
            f(&TextView::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::enable-language-menu\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_enable_language_menu_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn connect_property_inline_spell_checking_notify<F: Fn(&Self) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn notify_inline_spell_checking_trampoline<P, F: Fn(&P) + 'static>(
            this: *mut gspell_sys::GspellTextView,
            _param_spec: glib_sys::gpointer,
            f: glib_sys::gpointer,
        ) where
            P: IsA<TextView>,
        {
            let f: &F = &*(f as *const F);
            f(&TextView::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::inline-spell-checking\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_inline_spell_checking_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for TextView {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "TextView")
    }
}
